{
  - Master Cluster's Library -

  Copyright  1996-2004 Leonid Belousov (aka Master Cluster)
  mailto: mc@bramc.ru
  www.mastercluster.com

  - Description: Demo for Extended Stored Procedures component.
  - Demonstrates how to use bound connections and loopback connections.
}

{$IFDEF VER150}
  {$WARN UNSAFE_TYPE OFF}
  {$WARN UNSAFE_CODE OFF}
  {$WARN UNSAFE_CAST OFF}
{$ENDIF}

library xpTestLoopback;

uses
  Windows,
  SysUtils,
  XProc,
  ActiveX, ADODB;


{
sp_addextendedproc 'xp_TestLoopback', 'xpTest.dll'
go

begin tran
exec xp_TestLoopback
commit tran
}

function xp_TestLoopback(Handle: TXProcHandle): Integer; cdecl;
const
  adoConnectionStr = 'Provider=%s;User ID=%s;Password=%s;Data Source=%s;Initial Catalog=%s;';
var
  cnn: TADOConnection;
  qr: TADOQuery;
begin
  result := 0;
  CoInitialize(nil);

  with TXProc.Create(Handle) do
  try
    try
      cnn := TADOConnection.Create(nil);
      try
        cnn.ConnectionString := Format(adoConnectionStr, [
          'SQLOLEDB', 'sa', 'sapwd', 'SqlServerName', 'pubs'
        ]);

        cnn.Open;

        qr := TADOQuery.Create(nil);
        try
          qr.Connection := cnn;

          if GetBindToken <> '' then
          begin
            // We can share same transaction space, if needed...
            qr.SQL.Add('exec sp_bindsession ''' + GetBindToken + '''');
            qr.ExecSQL;
            qr.SQL.Clear;
          end;

          qr.SQL.Add('select * from titles');
          qr.Open;

          // Give names to output recordset columns
          Fields[0].Name := qr.Fields[0].FieldName;
          Fields[1].Name := qr.Fields[1].FieldName;

          while not qr.Eof do
          begin
            Fields[0].AsString := qr.Fields[0].AsString;
            Fields[1].AsString := qr.Fields[1].AsString;
            Fields.Next;

            qr.Next;
          end;

          qr.Close;
        finally
          qr.Free;
        end;

      finally
        cnn.Free;
      end;

      result := 1;
    except
      on E: Exception do RaiseError(E.Message);
    end;
  finally
    Free;
    CoUninitialize;
  end;
end;


exports
  xp_TestLoopback;

begin
end.
